<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/Formatters/HTML/Views/Tree.py.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/Formatters/HTML/Views/Tree.py</title>
<link href="../../../../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../../../../Scopes/Synopsis.html" >Global Package</a></span>
<span class="normal"><a href="../../../../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../../../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../../../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/Formatters/HTML/Views/Tree.py</b><pre class="sxr"><a id="line1"></a><span class="lineno"> 1</span><span class="line"><span class="py-comment">#</span></span>
<a id="line2"></a><span class="lineno"> 2</span><span class="line"><span class="py-comment"># Copyright (C) 2000 Stephen Davies</span></span>
<a id="line3"></a><span class="lineno"> 3</span><span class="line"><span class="py-comment"># Copyright (C) 2000 Stefan Seefeld</span></span>
<a id="line4"></a><span class="lineno"> 4</span><span class="line"><span class="py-comment"># All rights reserved.</span></span>
<a id="line5"></a><span class="lineno"> 5</span><span class="line"><span class="py-comment"># Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line6"></a><span class="lineno"> 6</span><span class="line"><span class="py-comment"># see the file COPYING for details.</span></span>
<a id="line7"></a><span class="lineno"> 7</span><span class="line"><span class="py-comment">#</span></span>
<a id="line8"></a><span class="lineno"> 8</span>
<a id="line9"></a><span class="lineno"> 9</span><span class="line"><span class="py-keyword">from</span> Synopsis <span class="py-keyword">import</span> config</span>
<a id="line10"></a><span class="lineno">10</span><span class="line"><span class="py-keyword">from</span> Synopsis.Processor <span class="py-keyword">import</span> Parameter</span>
<a id="line11"></a><span class="lineno">11</span><span class="line"><span class="py-keyword">from</span> Synopsis.Formatters.HTML.View <span class="py-keyword">import</span> View</span>
<a id="line12"></a><span class="lineno">12</span><span class="line"><span class="py-keyword">from</span> Synopsis.Formatters.HTML.Tags <span class="py-keyword">import</span> *</span>
<a id="line13"></a><span class="lineno">13</span><span class="line"><span class="py-keyword">import</span> os</span>
<a id="line14"></a><span class="lineno">14</span>
<a id="line15"></a><span class="lineno">15</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/Tree/Tree.html">Tree</a>(View):</span>
<a id="line16"></a><span class="lineno">16</span><span class="line">    <span class="py-string">&quot;&quot;&quot;View that makes Javascript trees. The trees have expanding and</span></span>
<a id="line17"></a><span class="lineno">17</span><span class="line"><span class="py-string">    collapsing nodes. call js_init() with the button images and default</span></span>
<a id="line18"></a><span class="lineno">18</span><span class="line"><span class="py-string">    open/close policy during process&quot;&quot;&quot;</span></span>
<a id="line19"></a><span class="lineno">19</span>
<a id="line20"></a><span class="lineno">20</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/Tree/Tree.html#register">register</a>(self, frame):</span>
<a id="line21"></a><span class="lineno">21</span>
<a id="line22"></a><span class="lineno">22</span><span class="line">        super(Tree, self).register(frame)</span>
<a id="line23"></a><span class="lineno">23</span><span class="line">        self.__id = 0</span>
<a id="line24"></a><span class="lineno">24</span><span class="line">        share = config.datadir</span>
<a id="line25"></a><span class="lineno">25</span><span class="line">        open_img = os.path.join(share, <span class="py-string">'syn-down.png'</span>)</span>
<a id="line26"></a><span class="lineno">26</span><span class="line">        close_img = os.path.join(share, <span class="py-string">'syn-right.png'</span>)</span>
<a id="line27"></a><span class="lineno">27</span><span class="line">        leaf_img = os.path.join(share, <span class="py-string">'syn-dot.png'</span>)</span>
<a id="line28"></a><span class="lineno">28</span><span class="line">        js = os.path.join(share, <span class="py-string">'html.js'</span>)</span>
<a id="line29"></a><span class="lineno">29</span><span class="line">        self.tree_open = <span class="py-string">'tree_open.png'</span></span>
<a id="line30"></a><span class="lineno">30</span><span class="line">        self.tree_close = <span class="py-string">'tree_close.png'</span></span>
<a id="line31"></a><span class="lineno">31</span><span class="line">        self.tree_leaf = <span class="py-string">'tree_leaf.png'</span></span>
<a id="line32"></a><span class="lineno">32</span><span class="line">        <span class="py-comment"># Copy resources across</span></span>
<a id="line33"></a><span class="lineno">33</span><span class="line">        self.directory_layout.copy_file(open_img, self.tree_open)</span>
<a id="line34"></a><span class="lineno">34</span><span class="line">        self.directory_layout.copy_file(open_img, self.tree_open)</span>
<a id="line35"></a><span class="lineno">35</span><span class="line">        self.directory_layout.copy_file(close_img, self.tree_close)</span>
<a id="line36"></a><span class="lineno">36</span><span class="line">        self.directory_layout.copy_file(leaf_img, self.tree_leaf)</span>
<a id="line37"></a><span class="lineno">37</span><span class="line">        self.directory_layout.copy_file(js, <span class="py-string">'synopsis.js'</span>)</span>
<a id="line38"></a><span class="lineno">38</span>
<a id="line39"></a><span class="lineno">39</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/Tree/Tree.html#get_id">get_id</a>(self):</span>
<a id="line40"></a><span class="lineno">40</span>
<a id="line41"></a><span class="lineno">41</span><span class="line">        self.__id += 1</span>
<a id="line42"></a><span class="lineno">42</span><span class="line">        <span class="py-keyword">return</span> <span class="py-string">'tree%d'</span>%self.__id</span>
<a id="line43"></a><span class="lineno">43</span>
<a id="line44"></a><span class="lineno">44</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/Tree/Tree.html#start_file">start_file</a>(self):</span>
<a id="line45"></a><span class="lineno">45</span>
<a id="line46"></a><span class="lineno">46</span><span class="line">        js = <span class="py-string">'&lt;script type=&quot;text/javascript&quot; src=&quot;synopsis.js&quot;&gt;&lt;/script&gt;'</span></span>
<a id="line47"></a><span class="lineno">47</span><span class="line">        View.start_file(self, headextra=js)</span>
<a id="line48"></a><span class="lineno">48</span>
<a id="line49"></a><span class="lineno">49</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/Tree/Tree.html#write_leaf">write_leaf</a>(self, text):</span>
<a id="line50"></a><span class="lineno">50</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Write a leaf node to the output at the current tree level.&quot;&quot;&quot;</span></span>
<a id="line51"></a><span class="lineno">51</span><span class="line">        i = img(src=self.tree_leaf, alt=<span class="py-string">'leaf'</span>)</span>
<a id="line52"></a><span class="lineno">52</span><span class="line">        self.write(div(<span class="py-string">'module-section'</span>, i + text) + <span class="py-string">'\n'</span>)</span>
<a id="line53"></a><span class="lineno">53</span>
<a id="line54"></a><span class="lineno">54</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/Tree/Tree.html#write_node_start">write_node_start</a>(self, text):</span>
<a id="line55"></a><span class="lineno">55</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Write a non-leaf node to the output at the current tree level, and</span></span>
<a id="line56"></a><span class="lineno">56</span><span class="line"><span class="py-string">        start a new level.&quot;&quot;&quot;</span></span>
<a id="line57"></a><span class="lineno">57</span><span class="line">        <span class="py-comment"># Get a unique id for this node</span></span>
<a id="line58"></a><span class="lineno">58</span><span class="line">        id = self.get_id()</span>
<a id="line59"></a><span class="lineno">59</span><span class="line">        <span class="py-comment"># Get the image for this node</span></span>
<a id="line60"></a><span class="lineno">60</span><span class="line">        node = img(id=<span class="py-string">'%s_img'</span>%id, src=self.tree_close, alt=<span class="py-string">'node'</span>, border=<span class="py-string">'0'</span>)</span>
<a id="line61"></a><span class="lineno">61</span><span class="line">        <span class="py-comment"># Get the scripted link for the image</span></span>
<a id="line62"></a><span class="lineno">62</span><span class="line">        link = href(<span class="py-string">&quot;javascript:toggle('%s');&quot;</span>%id, node)</span>
<a id="line63"></a><span class="lineno">63</span><span class="line">        <span class="py-comment"># Write the item</span></span>
<a id="line64"></a><span class="lineno">64</span><span class="line">        self.write(<span class="py-string">'&lt;div class=&quot;module-section&quot;&gt;%s%s'</span>%(link, text))</span>
<a id="line65"></a><span class="lineno">65</span><span class="line">        <span class="py-comment"># Start the (collapsible) section for the child nodes</span></span>
<a id="line66"></a><span class="lineno">66</span><span class="line">        self.write(<span class="py-string">'&lt;div id=&quot;%s&quot; style=&quot;display:none;&quot;&gt;\n'</span>%id)</span>
<a id="line67"></a><span class="lineno">67</span>
<a id="line68"></a><span class="lineno">68</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/Tree/Tree.html#write_node_end">write_node_end</a>(self):</span>
<a id="line69"></a><span class="lineno">69</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Finish a non-leaf node, and close the current tree level.&quot;&quot;&quot;</span></span>
<a id="line70"></a><span class="lineno">70</span>
<a id="line71"></a><span class="lineno">71</span><span class="line">        self.write(<span class="py-string">'&lt;/div&gt;\n&lt;/div&gt;\n'</span>)</span>
<a id="line72"></a><span class="lineno">72</span>
<a id="line73"></a><span class="lineno">73</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/Tree/Tree.html#end_tree">end_tree</a>(self):</span>
<a id="line74"></a><span class="lineno">74</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Writes the end of the tree.&quot;&quot;&quot;</span></span>
<a id="line75"></a><span class="lineno">75</span>
<a id="line76"></a><span class="lineno">76</span><span class="line">        js_end = <span class="py-string">&quot;&quot;&quot;&lt;script type=&quot;text/javascript&quot; language=&quot;JavaScript1.2&quot;&gt;&lt;!--</span></span>
<a id="line77"></a><span class="lineno">77</span><span class="line"><span class="py-string">        tree_max_node = %d; // --&gt;&lt;/script&gt;&quot;&quot;&quot;</span></span>
<a id="line78"></a><span class="lineno">78</span>
<a id="line79"></a><span class="lineno">79</span><span class="line">        self.write(js_end%self.__id)</span>
<a id="line80"></a><span class="lineno">80</span>
<a id="line81"></a><span class="lineno">81</span><span class="line">        self.write(div(<span class="py-string">'tree-navigation'</span>,</span>
<a id="line82"></a><span class="lineno">82</span><span class="line">                       href(<span class="py-string">'javascript:open_all()'</span>, <span class="py-string">'Open All'</span>) +</span>
<a id="line83"></a><span class="lineno">83</span><span class="line">                       href(<span class="py-string">'javascript:close_all()'</span>, <span class="py-string">'Close All'</span>)))</span>
<a id="line84"></a><span class="lineno">84</span>
<a id="line85"></a><span class="lineno">85</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:27:16 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../../../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
